
from loguru import logger
import time
import os
import inspect
from pysimpler.report import reporter

class timer:

    def ___get_func_info__(func):
        file_path = inspect.getsourcefile(func) # get filepaht
        file_path = "/".join(file_path.split("/")[-2:])
        name = func.__name__ # get func name
        return file_path, name


    @staticmethod
    def actual():
        
        def decorator(func):
            def wrapper(*args, **kwargs):

                if os.getenv("PYSIMPLER") == "1":
                    
                    function_file_path, function_name = timer.___get_func_info__(func)

                    s = time.perf_counter()
                    result = func(*args, **kwargs)
                    e = time.perf_counter()
                    logger.info(f"File: {function_file_path} | Function : {function_name} | Duration : {e-s} sec")
                    
                    key = function_file_path.split("/")[-1].split(".")[0]+"_"+function_name
                    val = e-s
                    reporter.add(key, val)
                else:
                    result = func(*args, **kwargs)
                return result
            return wrapper
        
        return decorator